data_gathering/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.contrib import admin
from django.conf.urls.static import static
from django.views.static import serve

from data_gathering.views import ProjectList, ProjectDetail

urlpatterns = [
    url(r'^admin/', admin.site.urls),

    url(r'^$', ProjectList.as_view(), name='project_list'),
    url(r'^files/', include('media_views.urls')),
    url(r'^(?P<pk>\d+)/$', ProjectDetail.as_view(), name='project_detail'),
    url(r'^static/(?P<path>.*)$', serve, {
	'document_root': settings.STATIC_ROOT,
	'show_indexes': True
    }),
]

media_views/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.contrib.auth.decorators import login_required

from .views import FolderView, upload_file

urlpatterns = [
    url(r'^browse/(?P<path>.*)$', login_required(FolderView.as_view()), name='media-file'),
    url(r'^upload/(?P<path>.*)$', login_required(upload_file), name='media-upload'),
]

data_gathering/models.py
import os

from django.db import models

class Project(models.Model):
    name = models.CharField(max_length=255)
    title = models.CharField(max_length=255)
    description = models.TextField()
    homepage = models.CharField(max_length=255)

    vcs_type = models.CharField(max_length=10, choices=(
        ("GIT", "Git"),
        ("SVN", "Subversion"),
    ))
    vcs_url = models.CharField(max_length=255)

    bugtracker_type = models.CharField(max_length=10, choices=(
        ("JIRA", "Jira"),
        ("GHUB", "Github"),
    ))
    bugtracker_url = models.URLField()
    bugtracker_api_root = models.URLField()

    prebuild_script = models.CharField(max_length=255, null=True, blank=True)
    postbuild_script = models.CharField(max_length=255, null=True, blank=True)
    cleanup_script = models.CharField(max_length=255, null=True, blank=True)


    def get_repo_local_path(self, repo_base):
        """ Returns a string which will be the location of the git repo on disk,
          if it exists
        """
        destination_repo = os.path.join(repo_base, self.name)
        return destination_repo

    def __str__(self):
        return "%s (%s)" % (self.title, self.name)

class ProjectIssue(models.Model):
    name = models.CharField(max_length=255)
    fix_version = models.ManyToManyField('data_gathering.ProjectVersion')
    created = models.DateTimeField(null=True, blank=True)
    updated = models.DateTimeField(null=True, blank=True)
    status = models.CharField(max_length=255, null=True, blank=True)
    issue_type = models.CharField(max_length=255)

class ProjectVersion(models.Model):
    project = models.ForeignKey('data_gathering.Project')
    self_url = models.URLField()
    self_id = models.CharField(max_length=255)
    description = models.TextField()
    name = models.CharField(max_length=255)

    git_tag = models.CharField(max_length=255, null=True)
    git_sha = models.CharField(max_length=40, null=True)

    def __str__(self):
        return "<%s>" % (self.name)

class MetricValue(models.Model):
    name = models.CharField(max_length=255)
    value = models.DecimalField(max_digits=19, decimal_places=5)

    project = models.ForeignKey('data_gathering.Project')
    git_sha = models.CharField(max_length=40, null=True)

    # Options to support a class/file, line number
    file = models.CharField(max_length=255, null=True, blank=True)
    line_number = models.IntegerField(null=True, blank=True)

media_views/models.py
from __future__ import unicode_literals

from django.db import models

# Create your models here.

media_views/forms.py
from django import forms

class UploadFileForm(forms.Form):
    file = forms.FileField(label="Upload File")

data_gathering/views.py
from django.views.generic import ListView, DetailView

from data_gathering.models import Project

class ProjectList(ListView):
    model = Project

class ProjectDetail(DetailView):
    model = Project

media_views/views.py
from django.conf import settings
from django.core.urlresolvers import reverse
from django.http import Http404, HttpResponse, HttpResponseRedirect
from django.shortcuts import render
from django.views.generic import TemplateView

import mimetypes
import os
import time

from .forms import UploadFileForm

def upload_file(request, **kwargs):
    if request.method == 'POST':
        form = UploadFileForm(request.POST, request.FILES)
        if form.is_valid():
            my_file = request.FILES['file']
            full_path = os.path.join(settings.MEDIA_ROOT, kwargs['path'], my_file.name)
            assert(full_path.startswith(settings.MEDIA_ROOT))
	    with open(full_path, 'wb+') as destination:
		for chunk in my_file.chunks():
		    destination.write(chunk)
            return HttpResponseRedirect(reverse('media-file', kwargs={"path": kwargs['path']}))
    raise Http404("File not found")

class FolderView(TemplateView):
    template_name = 'media_views/folder.html'
    def get_path(self, **kwargs):
        path = str(kwargs['path'])
        path = os.path.join(settings.MEDIA_ROOT, path)
        if not os.path.exists(path):
            raise Http404("File not found")
        if not path.startswith(settings.MEDIA_ROOT):
            raise Http404("File not found")
        return path
    def returns_file(self, **kwargs):
        path = self.get_path(**kwargs)
        if os.path.isfile(path):
            # Return file
            filename = path.split('/')[-1]
            with open(path, 'r') as f:
                self.blob = {
                    'name': filename,
                    'data': f.read(),
                    'size': os.path.getsize(path),
                }
            return True
        return False
    def get_context_data(self, **kwargs):
        context = super(FolderView, self).get_context_data(**kwargs)
        path = self.get_path(**kwargs)
        # Construct the list of files; make sure all are valid
        files = []
        for f in os.listdir(path):
            filename = f
            f = os.path.join(path, f)
            assert(f.startswith(settings.MEDIA_ROOT))
            # Get dir info
            file_stats = os.stat(f)
            file_stats = {
                'name': filename,
                'dir': os.path.isdir(f),
                'size': file_stats.st_size,
                'last_modified': time.ctime(file_stats.st_mtime),
                'path': os.path.join(self.url_path, filename),
            }
            files += [file_stats]
        # Sort
        files = sorted(files, key=lambda j: j['name'])
        context['object_list'] = files
        context['path_parts'] = self.url_path.split("/")
        context['path'] = self.url_path
        context['upload_form'] = UploadFileForm()
        return context
    def get(self, request, *args, **kwargs):
        self.url_path = kwargs['path']
        if self.returns_file(**kwargs):
            response = HttpResponse(content_type=mimetypes.guess_type(self.blob['name'])[0])
            response['Content-Length'] = self.blob['size']
            response.write(self.blob['data'])
            return response
        return super(FolderView,self).get(request, *args, **kwargs)

data_gathering/templates/data_gathering/project_detail.html
{% extends 'base.html' %}

{% block content %}
<h1>{{ object.name }} <small><a href="{{ object.homepage }}">homepage</a></small></h1>
<p>{{ object.description|safe }}</p>

<h2>Versions</h2>
<ul>
  {% for version in project.projectversion_set.all %}
    <li>{{ version }} <small>{{ version.git_sha }}, {{ version.projectissue_set.count }} issues</small>
  {% endfor %}
</ul>

<table>
  <tr>
    <th>Name</th>
    <th>Version</th>
    <th>Value</th>
  </tr>
{% for metric in object.metricvalue_set.all %}
  <tr>
    <td>{{ metric.name }}</td>
    <td>{{ metric.git_sha }}</td>
    <td>{{ metric.value }} </td>
  </tr>
{% endfor %}
</table>
{% endblock %}

data_gathering/templates/data_gathering/project_list.html
{% extends 'base.html' %}

{%block content %}
<ul>
  {% for object in object_list %}
    <li><a href="{% url 'project_detail' pk=object.id %}">{{ object }}</a> -- <a href="{{ object.bugtracker_url }}">issues</a> <a href="{{ object.vcs_url }}">code</a></li>
  {% endfor %}
</ul>
{% endblock %}

media_views/templates/media_views/folder.html
{% extends 'base.html' %}

{% block breadcrumbs %}
<ol class="breadcrumb">
  <li><a href={% url 'media-file' path="" %}>Root</a></li>
  {% for path in path_parts %}
    <li><a href="{% url 'media-file' path=path %}">{{ path }}</a></li>
  {% empty %}
  {% endfor %}
</ol>
{% endblock %}

{% block content %}
<p>
  <form action="{% url 'media-upload' path=path %}" method="post" enctype="multipart/form-data">
    {% csrf_token %}
  {{ upload_form }}
  <input type="submit" value="Submit" />
  </form>
</p>
<table class="table table-striped table-hover">
  <tr>
    <th>Name</th>
    <th>Size</th>
    <th>Last Modified</th>
  </tr>
  {% for object in object_list %}
    {% if object.dir %}
    <tr>
      <td><a href="{% url 'media-file' path=object.path %}">{{ object.name }}/</a></td>
      <td>{{ object.size|filesizeformat }}</td>
      <td>{{ object.last_modified }}</td>
    </tr>
    {% endif %}
  {% endfor %}
  {% for object in object_list %}
    {% if not object.dir %}
    <tr>
      <td><a href="{{ MEDIA_URL }}{{ object.path }}">{{ object.name }}</a></td>
      <td>{{ object.size|filesizeformat }}</td>
      <td>{{ object.last_modified }}</td>
    </tr>
    {% endif %}
  {% endfor %}
</table>
{% endblock %}

templates/base.html
<html>
<body>
  {% block content %}{% endblock %}
</body>
</html>